## launchy-2.9.1pre.1-3.src.tar.gz

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (LaunchyApp)

# // http://www.executionunit.com/blog/2014/01/22/moving-from-qmake-to-cmake/

set(PROJECT_VERSION_MAJOR 3)
set(PROJECT_VERSION_MINOR 0)
set(PROJECT_VERSION_PATCH 0)
set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})

set (CMAKE_AUTOMOC OFF)

configure_file (
	"${PROJECT_SOURCE_DIR}/win/launchy.rc.in"
	"${PROJECT_SOURCE_DIR}/win/launchy.rc"
	)
configure_file (
	"${PROJECT_SOURCE_DIR}/common/version.h.in"
	"${PROJECT_SOURCE_DIR}/common/version.h"
	)

if (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	set (CMAKE_PREFIX_PATH $ENV{QTDIR})
	set(__WIN__ TRUE)
	ADD_DEFINITIONS(-DUNICODE)
	ADD_DEFINITIONS(-D_UNICODE)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	set(__LIN__ TRUE)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    message (STATUS "In Mac mode")
	set(__MAC__ TRUE)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "BSD")
	set(__BSD__ TRUE)
endif()


set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

if(__MAC__)
	set(BUNDLE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}")
	set(BUNDLE_NAME "Launchy.app")
	set(MACOSX_BUNDLE_LONG_VERSION_STRING "${PROJECT_NAME}-${PROJECT_VERSION}")
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(BIN_INSTALL_DIR "${BUNDLE_NAME}/Contents/MacOS")
	set(RES_INSTALL_DIR "${BUNDLE_NAME}/Contents/Resources")

	#set(CMAKE_FIND_FRAMEWORK ONLY)
	find_library(CARBON_FRAMEWORK Carbon)
elseif(__LIN__ OR __BSD__)
	set(BIN_INSTALL_DIR "bin")
    set(RES_INSTALL_DIR "bin/Resources")
endif()
	

if(__LIN__)
	add_definitions(-DPREFIX="/usr")
	add_definitions(-DSKINS_PATH="$$PREFIX/share/launchy/skins/")
	add_definitions(-DPLUGINS_PATH="$$PREFIX/lib/launchy/plugins/")
	add_definitions(-DPLATFORMS_PATH="$$PREFIX/lib/launchy/")
	set(PREFIX "/usr")
	set(PREFIX_BIN ${PREFIX}/bin)
	set(PREFIX_PLUGINS ${PREFIX}/lib/launchy)
	set(PREFIX_SKINS ${PREFIX}/share/launchy)
	set(PREFIX_ICONS ${PREFIX}/share/launchy/plugins)
	set(PREFIX_DESKTOP ${PREFIX}/share/applications)
	set(PREFIX_DOC ${PREFIX}/share/doc/launchy)
	set(PREFIX_MENU ${PREFIX}/share/menu)
	set(PREFIX_PIXMAPS ${PREFIX}/share/pixmaps)
elseif(__BSD__)
	add_definitions(-DPREFIX="/usr/local")
	add_definitions(-DSKINS_PATH="$$PREFIX/share/launchy/skins/")
	add_definitions(-DPLUGINS_PATH="$$PREFIX/lib/launchy/plugins/")
	add_definitions(-DPLATFORMS_PATH="$$PREFIX/lib/launchy/")
	set(PREFIX "/usr/local")
	set(PREFIX_BIN ${PREFIX}/bin)
	set(PREFIX_PLUGINS ${PREFIX}/lib/launchy)
	set(PREFIX_SKINS ${PREFIX}/share/launchy)
	set(PREFIX_ICONS ${PREFIX}/share/launchy/plugins)
	set(PREFIX_DESKTOP ${PREFIX}/share/applications)
	set(PREFIX_DOC ${PREFIX}/share/doc/launchy)
	set(PREFIX_MENU ${PREFIX}/share/menu)
	set(PREFIX_PIXMAPS ${PREFIX}/share/pixmaps)
else()
	message (STATUS "Windows or Mac")
	set(PREFIX_BIN .)
	set(PREFIX .)
	set(PREFIX_PLUGINS ${PREFIX})
	set(PREFIX_SKINS ${PREFIX})
	set(PREFIX_ICONS ${PREFIX})
	set(PREFIX_DESKTOP ${PREFIX})
	set(PREFIX_DOC ${PREFIX}/doc)
	set(PREFIX_MENU ${PREFIX})
	set(PREFIX_PIXMAPS ${PREFIX})
endif()

# Qt
find_package(Qt5Core REQUIRED)
find_package(Qt5 COMPONENTS Gui Network Qml Quick Test Svg)

include_directories(${Qt5Widgets_INCLUDES})
add_definitions(${Qt5Widgets_DEFINITIONS})

include_directories(BEFORE ${CMAKE_SOURCE_DIR}/common)
include_directories(BEFORE ${CMAKE_SOURCE_DIR}/libqxt)

add_subdirectory(common)
add_subdirectory(libqxt)
add_subdirectory(plugins)
add_subdirectory(launchy)

enable_testing()
add_subdirectory(launchy.specs)


set(CPACK_PACKAGE_NAME, "Launchy")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Launchy application starter")
set(CPACK_PACKAGE_VENDOR "Code Jelly")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/../Readme.pdf")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE.txt")
set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_INSTALL_DIRECTORY "Launchy")
# set(CPACK_COMPONENTS_GROUPING "IGNORE")
set(CPACK_COMPONENTS_IGNORE_GROUPS 1)
set(CPACK_BUNDLE_NAME, "Launchy")
set(CPACK_BUNDLE_ICON, "${CMAKE_CURRENT_SOURCE_DIR}/Launchy.ico")
if(__WIN__)
	# There is a bug in NSI that does not handle full unix paths properly. Make
	# sure there is at least one set of four (4) backlasshes.
	set(CPACK_PACKAGE_FILE_NAME, "Launchy-Setup-${PROJECT_VERSION}")
	set(CPACK_PACKAGE_ICON, "${CMAKE_CURRENT_SOURCE_DIR}/Launchy.ico")
#    set(CPACK_PACKAGE_ICON "${CMake_SOURCE_DIR}/Utilities/Release\\\\InstallIcon.bmp")
    set(CPACK_NSIS_INSTALLED_ICON_NAME "launchy.exe")
    set(CPACK_NSIS_DISPLAY_NAME "Launchy")
    set(CPACK_NSIS_HELP_LINK "http:\\\\\\\\www.launchy.net")
    set(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.launchy.net\\\\about.php")
    set(CPACK_NSIS_CONTACT "joerg.preiss@slesa.de")
    set(CPACK_NSIS_MODIFY_PATH OFF)
    set(CPACK_NSIS_EXECUTABLES_DIRECTORY "")
    SET(CPACK_NSIS_CREATE_ICONS_EXTRA 
        "
            CreateShortcut \\\"$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\Launchy.lnk\\\" \\\"$INSTDIR\\\\launchy.exe\\\"
        " )
    SET(CPACK_NSIS_DELETE_ICONS_EXTRA 
        "
            Delete \\\"$SMPROGRAMS\\\\$STARTMENU_FOLDER\\\\Launchy.lnk\\\"
        " )
elseif(__MAC__)
    message (STATUS "Bundle name is" ${CPACK_BUNDLE_NAME})
    message (STATUS "Package name is" ${CPACK_PACKAGE_NAME})
	set(CPACK_GENERATOR "Bundle")
    set(CPACK_BUNDLE_NAME, "Launchy")
	set(CPACK_PACKAGE_VERSION, "1.0")
	set(CPACK_PACKAGE_FILE_NAME, "Launchy-Setup")
	set(CPACK_PACKAGE_ICON, "${CMAKE_CURRENT_SOURCE_DIR}/Launchy.ico")
	set(CPACK_BUNDLE_PLIST, "${CMAKE_CURRENT_SOURCE_DIR}/../mac/launchy.plist")
	set(CPACK_BUNDLE_STARTUP_COMMAND, "Contents/MacOS/Launchy")
elseif(__LIN__)
	set(CPACK_GENERATOR "DEB;RPM")
	set(CPACK_DEBIAN_PACKAGE_MAINTAINER "David Doria") 
	set(CPACK_PACKAGE_CONTACT "joerg.preiss@slesa.de")
	set(CPACK_DEB_COMPONENT_INSTALL ON)
	set(CPACK_DEB_USE_DISPLAY_NAME_IN_FILENAME, on)
	set(CPACK_RPM_PACKAGE_NAME "launchy")
	set(CPACK_RPM_PACKAGE_SUMMARY "Launchy is a free cross-platform utility designed to help you forget about your start menu, the icons on your desktop, and even your file manager. Launchy indexes the programs in your start menu and can launch your documents, project files, folders, and bookmarks with just a few keystrokes!")
	set(CPACK_RPM_PACKAGE_VERSION ${PROJECT_VERSION})
	set(CPACK_RPM_PACKAGE_RELEASE 1)
	set(CPACK_RPM_PACKAGE_LICENSE "unknown")
	set(CPACK_RPM_PACKAGE_GROUP "unknown")
	#set(CPACK_RPM_PACKAGE_REQUIRES "qt5" )
	set(CPACK_PACKAGE_FILE_NAME "launchy-${PROJECT_VERSION}")
	#required 
	#set(CPACK_DEBIAN_PACKAGE_DEPENDS "libqt5gui5, libqt5core libqt5network5 libqt5widgets5 libqt5x11extras5")
elseif(__BSD__)
	#set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
	#set(CPACK_STRIP_FILES "bin/Launchy")
	set(CPACK_SOURCE_STRIP_FILES "")
endif()
# set(CPACK_PACKAGE_EXECUTABLES launchy "Launchy")
set(CPACK_COMPONENT_launchy_DISPLAY_NAME "launchy")
set(CPACK_COMPONENT_skins_DISPLAY_NAME "launchy-skins")
set(CPACK_COMPONENT_skins_DEPENDS launchy)
set(CPACK_COMPONENT_plugins_DISPLAY_NAME "launchy-plugins")
set(CPACK_COMPONENT_plugins_DEPENDS launchy)
set(CPACK_COMPONENTS_ALL launchy plugins skins)

include(CPack)

# http://yanivresearch.info/software/CPackWindowsTutorial/CPackForWindows.html
# https://schneide.wordpress.com/2013/02/11/build-a-rpm-package-using-cmake/
# http://blog.beuc.net/posts/Build_a_SFML_project_with_CMake/
# https://github.com/biometrics/openbr/blob/master/share/openbr/example/CMakeLists.txt

=== src/common/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (common)

set (CMAKE_AUTOMOC OFF)


find_package(Qt5Core)
find_package(Qt5Widgets)

#  include_directories(${Qt5Widgets_INCLUDES})
#  add_definitions(${Qt5Widgets_DEFINITIONS})
#  set(CMAKE_CXX_FLAGS "${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")

if(__LIN__)
	find_package(Qt5 COMPONENTS X11Extras)
	set(launchy_common_mods
		X11Extras
	)
	get_target_property(QtExtras_location Qt5::X11Extras LOCATION)
elseif(__BSD__)
	find_package(Qt5 COMPONENTS X11Extras)
	set(launchy_common_mods
		X11Extras
	)
	get_target_property(QtExtras_location Qt5::X11Extras LOCATION)
elseif(__WIN__)
	find_package(Qt5 COMPONENTS winextras)
	set(launchy_common_mods
		WinExtras
	)
	get_target_property(QtExtras_location Qt5::WinExtras LOCATION)
elseif(__MAC__)
	find_package(Qt5 COMPONENTS macextras)
	set(launchy_common_mods
		MacExtras
	)
	get_target_property(QtExtras_location Qt5::MacExtras LOCATION)
endif()

set(launchy_common_moc_hdrs
	DropListWidget.h
	DropTableWidget.h
	FileBrowser.h
	FileBrowserDelegate.h
	globalshortcutmanager.h
	globalshortcuttrigger.h
	settingsmanager.h
)
set(launchy_common_srcs
	catalog.cpp
	DropListWidget.cpp
	DropTableWidget.cpp
	FileBrowser.cpp
	FileBrowserDelegate.cpp
	globals.cpp
	globalshortcutmanager.cpp
	platform_base.cpp
	settingsmanager.cpp
)
set(launchy_common_hdrs
	catalog.h
	directory.h
	globals.h
	platform_base.h
	version.h
)

if(__WIN__)
	include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})
	set(launchy_common_extra_moc_hdrs
		win_platform.h
	)
	set(launchy_common_extras
		win.cpp
		win_Iconprovider.cpp
		win_iconprovider.h
		win_files.h
		win_keytrigger.cpp
		win_minidump.cpp
		win_minidump.h
		win_platform.cpp
		win_util.cpp
		win_util.h
	)
elseif(__MAC__)
	set(launchy_common_extra_moc_hdrs
		mac_keytrigger.h
		mac_platform.h
	)
	set(launchy_common_extras
		mac.cpp
		mac_keytrigger.cpp
		mac_platform.cpp
	)
elseif(__LIN__)
	set(launchy_common_extra_moc_hdrs
		x11_keytrigger.h
		x11_platform.h
	)
	set(launchy_common_extras
		x11.cpp
		x11_iconprovider.cpp
		x11_iconprovider.h
		x11_keytrigger.cpp
		x11_platform.cpp
	)
elseif(__BSD__)
	set(launchy_common_extra_moc_hdrs
		x11_keytrigger.h
		x11_platform.h
	)
	set(launchy_common_extras
		x11.cpp
		x11_iconprovider.cpp
		x11_iconprovider.h
		x11_keytrigger.cpp
		x11_platform.cpp
	)
endif()

qt5_wrap_cpp(launchy_common_mocs ${launchy_common_moc_hdrs} ${launchy_common_extra_moc_hdrs})

add_library(common STATIC ${launchy_common_srcs} ${launchy_common_hdrs} ${launchy_common_extras} ${launchy_common_mocs} ${launchy_common_mochdrs} ${launchy_common_extra_mochdrs})
qt5_use_modules(common Core Widgets ${launchy_common_mods})
target_compile_features(common PRIVATE cxx_range_for)

if(__WIN__ OR __MAC__)
	install(FILES ${QtExtras_location} DESTINATION . COMPONENT PKG_MAIN)
endif()

=== src/launchy.specs/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (launchy_specs)

find_package(Qt5Core)
find_package(Qt5 COMPONENTS Core Gui Widgets Test)
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

enable_testing()

set(launchy_specs_hdrs
    commandlineparser.specs.h
    singleapplication.specs.h
    ../launchy/commandlineparser.h
    ../launchy/singleapplication.h
   )
set(launchy_specs_srcs
	main.cpp
    commandlineparser.specs.cpp
    singleapplication.specs.cpp
    ../launchy/commandlineparser.cpp
    ../launchy/singleapplication.cpp
   )
add_executable(launchy_specs ${launchy_specs_srcs} ${launchy_specs_hdrs})
qt5_use_modules(launchy_specs Core Gui Widgets Test)

# set_target_properties(launchy_specs PROPERTIES 
#    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR}/launchy.specs
#    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR}/launchy.specs
#    )

# get_target_property(OUTPUT_VALUE launchy_specs RUNTIME_OUTPUT_DIRECTORY)
# message(STATUS "This is the launchy_specs RUNTIME_OUTPUT_DIRECTORY:" ${OUTPUT_VALUE})


add_test( launchy_specs launchy_specs )
#add_test( NAME launchy_specs 
#    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/launchy_specs.exe
#    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
# add_test( NAME launchy_specs COMMAND "$<TARGET_FILE:launchy_specs>" )
# add_test( NAME launchy_specs COMMAND "../bin/launchy.specs/launchy_specs" )
# add_test( NAME launchy_specs COMMAND ${RUNTIME_OUTPUT_DIRECTORY}/launcy.specs/launchy_specs )

if(__WIN__)
    get_target_property(QtCore_location Qt5::Core LOCATION)
    file(COPY ${QtCore_location} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    get_target_property(QtTest_location Qt5::Test LOCATION)
    file(COPY ${QtTest_location} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
endif()

## http://doc.qt.io/qt-5/cmake-manual.html

=== src/launchy/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (launchy)

find_package(Qt5Core)
find_package(Qt5 COMPONENTS Gui Widgets Network)
find_package(Qt5LinguistTools)
if(__LIN__)
    find_package(X11 REQUIRED)
elseif(__MAC__)
    find_package(X11 REQUIRED)
elseif(__BSD__)
    find_package(X11 REQUIRED)
endif()

set(launchy_trans
    ../../translations/launchy_fr.ts
    ../../translations/launchy_nl.ts
    ../../translations/launchy_zh.ts
    ../../translations/launchy_es.ts
    ../../translations/launchy_de.ts
    ../../translations/launchy_ja.ts
    ../../translations/launchy_zh_TW.ts
    ../../translations/launchy_rus.ts)
set(launchy_srcs
	AnimationLabel.cpp
	catalog_builder.cpp
	catalog_types.cpp
	CharLineEdit.cpp
	CharListWidget.cpp
	CommandHistory.cpp
	commandlineparser.cpp
	dsingleapplication.cpp
	Fader.cpp
	FileSearch.cpp
	icon_delegate.cpp
	icon_extractor.cpp
	InputDataList.cpp
	launchywidget.cpp
	LineEditMenu.cpp
	main.cpp
	optionsdialog.cpp
	platform_util.cpp
	plugin_handler.cpp
	plugin_interface.cpp
	singleapplication.cpp
   )
if(__WIN__)
	set(launchy_win_srcs
		win_launchywidget.cpp
		win_launchywidget.h
		../../win/launchy.rc
	)
    find_package(Qt5 COMPONENTS winextras)
    set(launchy_mods
        WinExtras
    )
endif()

QT5_WRAP_UI(launchy_form_hdr options.ui)
QT5_ADD_TRANSLATION(launchy_qms ${launchy_trans})
QT5_ADD_RESOURCES(launchy_qrcs launchy.qrc)

include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/libqxt)
#if (__LIN__)
	find_package(X11 REQUIRED)
    include_directories(${X11_INCLUDE_DIR})
#endif(__LIN__)

add_executable(launchy ${launchy_srcs} ${launchy_form_hdr} ${launchy_common_hdrs} ${launchy_hdr_moc} ${launchy_qms} ${launchy_win_srcs} ${launchy_qrcs})

qt5_use_modules(launchy Core Gui Widgets Network ${launchy_mods})

target_link_libraries(launchy common libqxt)
if(__LIN__)
    target_link_libraries(launchy ${X11_LIBRARIES})
elseif (__BSD__)
    target_link_libraries(launchy ${X11_LIBRARIES})
elseif (__MAC__)
	target_link_libraries(launchy ${CARBON_FRAMEWORK})
endif()

set_target_properties(launchy PROPERTIES 
    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR}
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR}
    )

if(EXISTS ${PROJECT_BINARY_DIR}/launchy_fr.qm)
    file(COPY ${launchy_qms} DESTINATION ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR}/tr)
endif()
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../../skins DESTINATION ${PROJECT_BINARY_DIR}/../${RES_INSTALL_DIR})

get_target_property(QtCore_location Qt5::Core LOCATION)
get_target_property(QtGui_location Qt5::Gui LOCATION)
get_target_property(QtWidgets_location Qt5::Widgets LOCATION)
get_target_property(QtNetwork_location Qt5::Network LOCATION)
if(__WIN__ OR __MAC__)
    file(COPY ${QtCore_location} DESTINATION ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR})
    file(COPY ${QtGui_location} DESTINATION ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR})
    file(COPY ${QtWidgets_location} DESTINATION ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR})
    file(COPY ${QtNetwork_location} DESTINATION ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR})
    if(__WIN__)
        get_target_property(QtWinExtras_location Qt5::WinExtras LOCATION)
        file(COPY ${QtWinExtras_location} DESTINATION ${PROJECT_BINARY_DIR}/../${BIN_INSTALL_DIR})
    endif()
endif()

target_link_libraries(launchy common libqxt ${Qt5Core_QTMAIN_LIBRARIES})

if(__WIN__)
    set_target_properties(launchy PROPERTIES LINK_FLAGS_DEBUG "/SUBSYSTEM:WINDOWS")
    set_target_properties(launchy PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS")
endif(__WIN__)

add_custom_target(readme_gz ALL COMMAND
    ${CMAKE_COMMAND} -E tar "cfvz" "Readme.pdf.gz" ${CMAKE_CURRENT_SOURCE_DIR}/../../Readme.pdf)
# add_dependencies(readme_gz "${CMAKE_CURRENT_SOURCE_DIR}/../../Readme.pdf")
# add_dependencies(launchy readme_gz)


# *** Installation ***
install(TARGETS launchy RUNTIME DESTINATION ${PREFIX_BIN} COMPONENT launchy)
if(__WIN__ OR __MAC__)
	install(FILES 
		${QtCore_location}
		${QtGui_location}
		${QtWidgets_location}
		${QtNetwork_location}
		DESTINATION ${PREFIX_BIN}
        COMPONENT launchy)
	install(FILES ${launchy_qms} DESTINATION ${PREFIX_BIN}/tr COMPONENT launchy)
    if(__WIN__)
    install(FILES ${QtWinExtras_location} DESTINATION ${PREFIX_BIN} COMPONENT launchy)
    endif()
endif()
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../skins/Default DESTINATION ${PREFIX_SKINS}/skins COMPONENT launchy)
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../skins/ 
    DESTINATION ${PREFIX_SKINS}/skins 
    COMPONENT skins
    PATTERN "Default" EXCLUDE
    )
if(__LIN__)
    install(FILES 
        ${CMAKE_CURRENT_SOURCE_DIR}/../linux/debian/launchy
        DESTINATION ${PREFIX_MENU}
        COMPONENT launchy)
    install(FILES 
        ${CMAKE_CURRENT_SOURCE_DIR}/../misc/icon/launchy_icon.png 
        DESTINATION ${PREFIX_PIXMAPS}
        COMPONENT launchy)
    install(FILES 
        ${CMAKE_CURRENT_SOURCE_DIR}/../linux/launchy.desktop 
        DESTINATION ${PREFIX_DESKTOP} 
        COMPONENT launchy)
    install(FILES 
        ${CMAKE_CURRENT_BINARY_DIR}/Readme.pdf.gz
        ${CMAKE_CURRENT_SOURCE_DIR}/../linux/debian/copyright 
        ${CMAKE_CURRENT_SOURCE_DIR}/../../changelog
        ${CMAKE_CURRENT_SOURCE_DIR}/../../readme.txt
        ${CMAKE_CURRENT_SOURCE_DIR}/../../plugin_api/api.html
        DESTINATION ${PREFIX_DOC} 
        COMPONENT launchy)
endif(__LIN__)

=== src/libqxt/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (libqxt)

find_package(Qt5Core)
find_package(Qt5 COMPONENTS Gui Widgets)
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

add_definitions(-DQXT_STATIC)


set(launchy_qxt_srcs
	qxtglobalshortcut.cpp
	)
if(__WIN__)
set(launchy_qxt_extras
	qxtglobalshortcut_win.cpp
	)
elseif(__MAC__)
set(launchy_qxt_extras
	qxtglobalshortcut_mac.cpp
	)
elseif(__LIN__)
set(launchy_qxt_extras
	qxtglobalshortcut_x11.cpp
	)
elseif(__BSD__)
set(launchy_qxt_extras
	qxtglobalshortcut_x11.cpp
	)
endif()

add_library(libqxt STATIC ${launchy_qxt_srcs} ${launchy_qxt_extras})
qt5_use_modules(libqxt Core Gui Widgets)

=== src/plugins/CMakeLists.txt ===
#set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BIN_PLUGINS_DIR})
#set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${BIN_PLUGINS_DIR})
set(CMAKE_MACOSX_RPATH 0)

add_subdirectory(runner)
add_subdirectory(verby)
add_subdirectory(weby)

if(__WIN__)
	add_subdirectory(controly)
endif()

=== src/plugins/controly/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (controly)

find_package(Qt5Core)
find_package(Qt5 COMPONENTS Gui Widgets Network)
find_package(Qt5LinguistTools)

#include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

set(launchy_controly_trans
    ../../../translations/controly_fr.ts
    ../../../translations/controly_nl.ts
    ../../../translations/controly_zh.ts
    ../../../translations/controly_es.ts
    ../../../translations/controly_de.ts
    ../../../translations/controly_ja.ts
    ../../../translations/controly_zh_TW.ts
    ../../../translations/controly_rus.ts   
    )
set(launchy_controly_srcs
    gui.cpp
    controly.cpp
    ControlPanelItemFinder.cpp
    fhoicon.cpp
    fhoenv.cpp
    fhoreg.cpp
    fhores.cpp
    ../../launchy/plugin_interface.cpp
    ../../common/DropTableWidget.cpp
   )
set(launchy_controly_hdrs
    globals.h
	gui.h
	controly.h
    ControlPanelItemFinder.h
    fhoicon.h
    fhoenv.h
    fhoreg.h
    fhores.h
    ../../launchy/plugin_interface.h
    ../../common/DropTableWidget.h
   )
set(controly_pngs
   controly.png
   launchy.exit.png
   launchy.options.png
   launchy.rebuild.png
   )

if(__WIN__)
    find_package(Qt5 COMPONENTS winextras)
    set(launchy_controly_mods
        WinExtras
    )
endif()

include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/launchy)

QT5_WRAP_UI(launchy_controly_form dlg.ui)
QT5_ADD_TRANSLATION(launchy_controly_qms ${launchy_controly_trans})

add_library(controly SHARED ${launchy_controly_srcs} ${launchy_controly_hdrs} ${launchy_controly_form} ${launchy_controly_qms})
#target_link_libraries(controly common)
qt5_use_modules(controly Core Gui Widgets Network ${launchy_controly_mods})


# *** Installation ***
install(TARGETS controly DESTINATION ${PREFIX_PLUGINS}/plugins)
install(FILES ${controly_pngs} DESTINATION ${PREFIX_ICONS}/icons COMPONENT plugins)
if(__WIN__ OR __MAC__)
    install(FILES ${launchy_controly_qms} DESTINATION ${PREFIX_PLUGINS}/tr COMPONENT plugins)
endif()

=== src/plugins/runner/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (runner)

find_package(Qt5Core)
find_package(Qt5 COMPONENTS Gui Widgets)
find_package(Qt5LinguistTools)

set(launchy_runner_trans
    ../../../translations/runner_fr.ts
    ../../../translations/runner_nl.ts
    ../../../translations/runner_zh.ts
    ../../../translations/runner_es.ts
    ../../../translations/runner_de.ts
    ../../../translations/runner_ja.ts
    ../../../translations/runner_zh_TW.ts
    ../../../translations/runner_rus.ts   
    )
set(launchy_runner_srcs
	gui.cpp
	runner.cpp
    ../../common/FileBrowser.cpp
    ../../common/FileBrowserDelegate.cpp
    ../../common/DropTableWidget.cpp
    ../../launchy/plugin_interface.cpp
   )
set(launchy_runner_hdrs
	globals.h
	gui.h
	runner.h
	winfiles.h
    ../../common/FileBrowserDelegate.h
    ../../common/FileBrowser.h
    ../../common/DropTableWidget.h
    ../../launchy/plugin_interface.h
   )
set(runnery_pngs
   runner.png)


include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/launchy)

QT5_WRAP_UI(launchy_runner_form dlg.ui)
QT5_ADD_TRANSLATION(launchy_runner_qms ${launchy_runner_trans})

add_library(runner SHARED ${launchy_runner_srcs} ${launchy_runner_hdrs} ${launchy_runner_form} ${launchy_runner_qms})
set_target_properties(runner PROPERTIES 
    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/plugins
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/plugins
    )
qt5_use_modules(runner Core Gui Widgets)
if(EXISTS "${PROJECT_BINARY_DIR}/runner_fr.qm")
    file(COPY ${launchy_runner_qms} DESTINATION ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/tr)
endif()


# *** Installation ***
install(TARGETS runner DESTINATION ${PREFIX_PLUGINS}/plugins COMPONENT plugins)
install(FILES ${runner_pngs} DESTINATION ${PREFIX_ICONS}/icons COMPONENT plugins)
if(__WIN__ OR __MAC__)
    install(FILES ${launchy_runner_qms} DESTINATION ${PREFIX_PLUGINS}/tr COMPONENT plugins)
endif()

=== src/plugins/verby/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (verby)

find_package(Qt5Core)
find_package(Qt5 COMPONENTS Gui Widgets)
find_package(Qt5LinguistTools)

#include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

set(launchy_verby_trans
    ../../../translations/verby_fr.ts
    ../../../translations/verby_nl.ts
    ../../../translations/verby_zh.ts
    ../../../translations/verby_es.ts
    ../../../translations/verby_de.ts
    ../../../translations/verby_ja.ts
    ../../../translations/verby_zh_TW.ts
    ../../../translations/verby_rus.ts   
    )
set(launchy_verby_srcs
	gui.cpp
	Verby.cpp
	../../launchy/plugin_interface.cpp
	)
set(launchy_verby_hdrs
	gui.h
	Verby.h
	../../launchy/plugin_interface.h
	)
set(verby_pngs
   copy.png
   opencontainer.png
   properties.png
   run.png
   verby.png)


include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/launchy)

QT5_WRAP_UI(launchy_verby_form dlg.ui)
QT5_ADD_TRANSLATION(launchy_verby_qms ${launchy_verby_trans})

add_library(verby SHARED ${launchy_verby_srcs} ${launchy_verby_hdrs} ${launchy_verby_form} ${launchy_verby_qms})
set_target_properties(verby PROPERTIES 
    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/plugins
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/plugins
    )
qt5_use_modules(verby Core Gui Widgets)
if(EXISTS "${PROJECT_BINARY_DIR}/verby_fr.qm")
    file(COPY ${launchy_verby_qms} DESTINATION ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/tr)
endif()


# *** Installation ***
install(TARGETS verby DESTINATION ${PREFIX_PLUGINS}/plugins COMPONENT plugins)
install(FILES ${verby_pngs} DESTINATION ${PREFIX_ICONS}/icons COMPONENT plugins)
if(__WIN__ OR __MAC__)
    install(FILES ${launchy_verby_qms} DESTINATION ${PREFIX_PLUGINS}/tr COMPONENT plugins)
endif()

=== src/plugins/weby/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5.1)
project (weby)

find_package(Qt5Core)
find_package(Qt5 COMPONENTS Gui Widgets Network)
find_package(Qt5LinguistTools)

#include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

set(launchy_weby_trans
    ../../../translations/weby_fr.ts
    ../../../translations/weby_nl.ts
    ../../../translations/weby_zh.ts
    ../../../translations/weby_es.ts
    ../../../translations/weby_de.ts
    ../../../translations/weby_ja.ts
    ../../../translations/weby_zh_TW.ts
    ../../../translations/weby_rus.ts   
    )
set(launchy_weby_srcs
	gui.cpp
	IconCache.cpp
	weby.cpp
    ../../launchy/plugin_interface.cpp
    ../../common/DropTableWidget.cpp
   )
set(launchy_weby_hdrs
globals.h
	gui.h
	IconCache.h
	weby.h
    ../../launchy/plugin_interface.h
    ../../common/DropTableWidget.h
   )
set(weby_pngs
   weby.png)

include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/common)
include_directories(${CMAKE_SOURCE_DIR}/launchy)

QT5_WRAP_UI(launchy_weby_form dlg.ui)
QT5_ADD_TRANSLATION(launchy_weby_qms ${launchy_weby_trans})

add_library(weby SHARED ${launchy_weby_srcs} ${launchy_weby_hdrs} ${launchy_weby_form} ${launchy_weby_qms})
set_target_properties(weby PROPERTIES 
    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/plugins
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/plugins
    )
qt5_use_modules(weby Core Gui Widgets Network)
if(EXISTS "${PROJECT_BINARY_DIR}/weby_fr.qm")
    file(COPY ${launchy_weby_qms} DESTINATION ${PROJECT_BINARY_DIR}/../../${BIN_INSTALL_DIR}/tr)
endif()


# *** Installation ***
install(TARGETS weby DESTINATION ${PREFIX_PLUGINS}/plugins COMPONENT plugins)
install(FILES ${weby_pngs} DESTINATION ${PREFIX_ICONS}/icons COMPONENT plugins)
if(__WIN__ OR __MAC__)
    install(FILES ${launchy_weby_qms} DESTINATION ${PREFIX_PLUGINS}/tr COMPONENT plugins)
endif()

=== PKGBUILD ===
# Contributor: Andrew Burkett <burkett.andrew@gmail.com>
# Maintainer: Daniel J Griffiths <ghost1227@archlinux.us>

pkgname=launchy
_pkgver=2.9.1-pre.1
pkgver=${_pkgver/-/}
pkgrel=3
pkgdesc="Indexes the programs in your start menu and can launch your documents, project files, folders, and bookmarks with just a few keystrokes!"
arch=('x86_64')
url="https://www.launchy.net/"
license=('GPL')
depends=('qt5-x11extras' 'qt5-declarative' 'qt5-svg')
makedepends=('qt5-tools' 'boost' 'cmake')
source=($pkgname-$pkgver.tar.gz::"https://github.com/Slesa/launchy/archive/v$_pkgver.tar.gz")
sha512sums=('54d27e39a86f4b9c3d7a2770d06ef6a6bcdc5dee770e523c9fcb9dd3c25c7de1705c9f0d0b5452a9b7d20b607a998ad7faa713aa6566dc3f406cacb14a84f8bd')

build() {
  cd ${pkgname}-${_pkgver}/src

  cmake . \
    -DCMAKE_INSTALL_PREFIX=/usr
  make
}

package() {
  cd ${pkgname}-${_pkgver}/src

  make DESTDIR="${pkgdir}" install
}
